
url = "http://api.sensor.community/v1/push-sensor-data/"

if sensorid == nil then
suffix = string.gsub(node.chipid(), "0x", "")
msn_suffix = string.sub(suffix, 3, 6)
lsn_suffix = string.sub(suffix, 7, 12)
msn_suffix_dec = tonumber(msn_suffix, 16)
lsn_suffix_dec = tonumber(lsn_suffix, 16)
suffix_dec = msn_suffix_dec .. lsn_suffix_dec
sensorid = "esp32-" .. suffix_dec
print(sensorid)
end

function postsensordata ()
  if body ~= nil then 
  http.post(url, { headers = headers }, body,
      function(code, pdata)
        if (code < 0) then
          print("HTTP request failed")
        else
          print(code, pdata)
        end
      end)
    end
  end


print(sensorid)

print("hpostsctimer started")

hpostsctimer = tmr.create()
hpostsctimer:register(130000, tmr.ALARM_AUTO, function()
			
body = nil

if Temperature == nil then Temperature = 23.3 end
if Humidity == nil then Humidity = 60.4 end
if Pressure == nil then Pressure = 102450 end

headers = {
  ["Content-Type"] = "application/json", 
  ["X-Pin"] = "1", 
  ["X-Sensor"] = "".. sensorid .."",
}

print(headers["Content-Type"], headers["X-Pin"], headers["X-Sensor"])


-- Sensor SDS011
if sds011pm2_5 ~= nil then 

if snsdiff == 1 then sds011pm10 = sds011pm10 - sds011pm2_5 end

bodySDS011 = "{\"software_version\": \"".. firmware_type .. "\", \"sensordatavalues\":[ {\"value_type\":\"P1\",\"value\":\"" .. sds011pm2_5 .. "\"}, {\"value_type\":\"P2\",\"value\":\"" .. sds011pm10 .. "\"}]}"  

body = bodySDS011

end

-- Sensor SPS30

if MassConcentrationPM1 ~= nil then

bodySPS30 = "{\"software_version\": \"".. firmware_type .. "\", \"sensordatavalues\":[ {\"value_type\":\"P0\",\"value\":\"" .. MassConcentrationPM1 .. "\"}, {\"value_type\":\"P2\",\"value\":\"" .. MassConcentrationPM2d5 .. "\"}, {\"value_type\":\"P4\",\"value\":\"" .. MassConcentrationPM4 .. "\"}, {\"value_type\":\"P1\",\"value\":\"" .. MassConcentrationPM10 .. "\"}, {\"value_type\":\"N05\",\"value\":\"" .. NumberConcentrationPM05 .. "\"}, {\"value_type\":\"N1\",\"value\":\"" .. NumberConcentrationPM1 .. "\"}, {\"value_type\":\"N25\",\"value\":\"" .. NumberConcentrationPM2d5 .. "\"}, {\"value_type\":\"N4\",\"value\":\"" .. NumberConcentrationPM4 .. "\"}, {\"value_type\":\"N10\",\"value\":\"" .. NumberConcentrationPM10 .. "\"}, {\"value_type\":\"TS\",\"value\":\"" .. TypicalParticleSizeNm/1000 .. "\"}]}"  

body = bodySPS30

end

print(body)

postsensordata()

headers = {
  ["Content-Type"] = "application/json", 
  ["X-Pin"] = "11", 
  ["X-Sensor"] = "".. sensorid .."",
}

bodyBME280 = "{\"software_version\": \"".. firmware_type .. "\", \"sensordatavalues\":[{\"value_type\":\"temperature\",\"value\":\"" .. Temperature .. "\"},{\"value_type\":\"humidity\",\"value\":\"" .. Humidity .. "\"}, {\"value_type\":\"pressure\",\"value\":\"" .. Pressure .. "\"} ]}"  

body = bodyBME280
print(headers["Content-Type"], headers["X-Pin"], headers["X-Sensor"])

print(body)

postsensordata()

end)

hpostsctimer:start()
