
sds011 = require("sds011")

polltimer = tmr.create()
polling = false

function setup_client()
	print("Connected")
	-- gpio.write(ledpin, 1)
	--port = softuart.setup(9600, 16, 17)
	uart.setup(2, 9600, 8, uart.PARITY_NONE, uart.STOPBITS_1, {rx = 16, tx = 17})
	uart.on(2,"data", 10, uart_callback)
	uart.start(2)
	uart.write(2, sds011.set_work_period(1))
	end
-- end


function uart_callback(data)
	if not sds011.parse_frame(data) then
		print("Invalid or data-less SDS011 frame")
		return
	end
	local work_period = "continuous"
	if sds011.work_period > 0 then
		work_period = string.format("%d min", sds011.work_period)
	end

	if sds011.work_period == 0 and not polling then
		polling = true
		uart.write(2,sds011.set_report_mode(false))
		polltimer:start()
	end
	if sds011.work_period > 0 and polling then
		polling = false
		uart.write(2, sds011.set_report_mode(true))
		polltimer:stop()
	end

--	local json_str = string.format('{"rssi_dbm":%d,"period":"%s"', wifi.sta.getrssi(), work_period)
--	local influx_str = ""
	if sds011.pm2_5i ~= nil then
		--json_str = string.format('%s,"pm2_5_ugm3":%d.%d,"pm10_ugm3":%d.%d', json_str, sds011.pm2_5i, sds011.pm2_5f, sds011.pm10i, sds011.pm10f)
		--influx_str = string.format("pm2_5_ugm3=%d.%d,pm10_ugm3=%d.%d", sds011.pm2_5i, sds011.pm2_5f, sds011.pm10i, sds011.pm10f)
		--print(string.format("pm2_5_ugm3=%d.%d", sds011.pm2_5i, sds011.pm2_5f))
		--print(string.format("pm10_ugm3=%d.%d", sds011.pm10i, sds011.pm10f))
		sds011pm2_5 = string.format("%d.%d", sds011.pm2_5i, sds011.pm2_5f)
		sds011pm10 = string.format("%d.%d", sds011.pm10i, sds011.pm10f)
		-- print("Result:")
		print("sds011pm2_5_ug3 = ", sds011pm2_5)
		print("sds011pm10_ug3 = ", sds011pm10)
		
	end
--	json_str = json_str .. '}'

end

function query_data()
	uart.write(2,sds011.query())
end

setup_client()
polltimer:register(10 * 1000, tmr.ALARM_AUTO, query_data)
